diff --git a/src/odbc/unittests/funccall.c b/src/odbc/unittests/funccall.c
index 0773818..bf80de9 100644
--- a/src/odbc/unittests/funccall.c
+++ b/src/odbc/unittests/funccall.c
@@ -2,7 +2,7 @@
 
 /* Test for {?=call store(?)} syntax and run */
 
-static char software_version[] = "$Id: funccall.c,v 1.14 2007/04/12 13:36:14 freddy77 Exp $";
+static char software_version[] = "$Id: funccall.c,v 1.15 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -15,29 +15,20 @@ main(int argc, char *argv[])
 
 	Connect();
 
-	if (CommandWithResult(Statement, "drop proc simpleresult") != SQL_SUCCESS)
-		printf("Unable to execute statement\n");
+	Command(Statement, "IF OBJECT_ID('simpleresult') IS NOT NULL DROP PROC simpleresult");
 
 	Command(Statement, "create proc simpleresult @i int as begin return @i end");
 
-	if (SQLBindParameter(Statement, 2, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &input, 0, &ind2) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to bind input parameter");
+	CHK(SQLBindParameter, (Statement, 2, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &input, 0, &ind2));
 
-	if (SQLBindParameter(Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to bind output parameter");
+	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind));
 
-	if (SQLPrepare(Statement, (SQLCHAR *) "{ \n?\t\r= call simpleresult(?)}", SQL_NTS) != SQL_SUCCESS) {
-		printf("Unable to prepare statement\n");
-		exit(1);
-	}
+	CHK(SQLPrepare, (Statement, (SQLCHAR *) "{ \n?\t\r= call simpleresult(?)}", SQL_NTS));
 
 	input = 123;
 	ind2 = sizeof(input);
 	output = 0xdeadbeef;
-	if (SQLExecute(Statement) != SQL_SUCCESS) {
-		printf("Unable to execute statement\n");
-		exit(1);
-	}
+	CHK(SQLExecute, (Statement));
 
 	if (output != 123) {
 		printf("Invalid result\n");
@@ -57,26 +48,22 @@ main(int argc, char *argv[])
 	input = 567;
 	ind2 = sizeof(input);
 	output = 0xdeadbeef;
-	if (SQLExecDirect(Statement, (SQLCHAR *) "{?=call simpleresult(?)}", SQL_NTS) != SQL_SUCCESS) {
-		printf("Unable to execure direct statement\n");
-		exit(1);
-	}
+	CHK(SQLExecDirect, (Statement, (SQLCHAR *) "{?=call simpleresult(?)}", SQL_NTS));
 
 	if (output != 567) {
-		printf("Invalid result\n");
+		fprintf(stderr, "Invalid result\n");
 		exit(1);
 	}
 
 	/* should return "Invalid cursor state" */
 	if (SQLFetch(Statement) != SQL_ERROR) {
-		printf("Data not expected\n");
+		fprintf(stderr, "Data not expected\n");
 		exit(1);
 	}
 
 	Command(Statement, "drop proc simpleresult");
 
-	if (CommandWithResult(Statement, "drop proc simpleresult2") != SQL_SUCCESS)
-		printf("Unable to execute statement\n");
+	Command(Statement, "IF OBJECT_ID('simpleresult2') IS NOT NULL DROP PROC simpleresult2");
 
 	/* force cursor close */
 	SQLCloseCursor(Statement);
@@ -85,31 +72,12 @@ main(int argc, char *argv[])
 	Command(Statement,
 		"create proc simpleresult2 @i int, @x int output, @y varchar(20) output as begin select @x = 6789 select @y = 'test foo' return @i end");
 
-	if (SQLBindParameter(Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind) != SQL_SUCCESS) {
-		printf("Unable to bind output parameter\n");
-		exit(1);
-	}
+	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0,  0, &output, 0,            &ind));
+	CHK(SQLBindParameter, (Statement, 2, SQL_PARAM_INPUT,  SQL_C_SLONG, SQL_INTEGER, 0,  0, &input,  0,            &ind2));
+	CHK(SQLBindParameter, (Statement, 3, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0,  0, &out1,   0,            &ind3));
+	CHK(SQLBindParameter, (Statement, 4, SQL_PARAM_OUTPUT, SQL_C_CHAR,  SQL_VARCHAR, 20, 0, out2,    sizeof(out2), &ind4));
 
-	if (SQLBindParameter(Statement, 2, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &input, 0, &ind2) != SQL_SUCCESS) {
-		printf("Unable to bind input parameter\n");
-		exit(1);
-	}
-
-	if (SQLBindParameter(Statement, 3, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &out1, 0, &ind3) != SQL_SUCCESS) {
-		printf("Unable to bind output parameter\n");
-		exit(1);
-	}
-
-	if (SQLBindParameter(Statement, 4, SQL_PARAM_OUTPUT, SQL_C_CHAR, SQL_VARCHAR, 20, 0, out2, sizeof(out2), &ind4) !=
-	    SQL_SUCCESS) {
-		printf("Unable to bind output parameter\n");
-		exit(1);
-	}
-
-	if (SQLPrepare(Statement, (SQLCHAR *) "{ \n?\t\r= call simpleresult2(?,?,?)}", SQL_NTS) != SQL_SUCCESS) {
-		printf("Unable to prepare statement\n");
-		exit(1);
-	}
+	CHK(SQLPrepare, (Statement, (SQLCHAR *) "{ \n?\t\r= call simpleresult2(?,?,?)}", SQL_NTS));
 
 	input = 987;
 	ind2 = sizeof(input);
@@ -117,10 +85,7 @@ main(int argc, char *argv[])
 	output = 0xdeadbeef;
 	ind3 = SQL_DATA_AT_EXEC;
 	ind4 = SQL_DEFAULT_PARAM;
-	if (SQLExecute(Statement) != SQL_SUCCESS) {
-		printf("Unable to execute statement\n");
-		exit(1);
-	}
+	CHK(SQLExecute, (Statement));
 
 	if (output != 987 || ind3 <= 0 || ind4 <= 0 || out1 != 6789 || strcmp(out2, "test foo") != 0) {
 		printf("ouput = %d ind3 = %d ind4 = %d out1 = %d out2 = %s\n", (int) output, (int) ind3, (int) ind4, (int) out1,
@@ -131,7 +96,7 @@ main(int argc, char *argv[])
 
 	/* should return "Invalid cursor state" */
 	if (SQLFetch(Statement) != SQL_ERROR) {
-		printf("Data not expected\n");
+		fprintf(stderr, "Data not expected\n");
 		exit(1);
 	}
 
@@ -142,42 +107,33 @@ main(int argc, char *argv[])
 	 * Cfr ML 2006-11-21 "specifying a 0 for the StrLen_or_IndPtr in the
 	 * SQLBindParameter call is not working on AIX"
 	 */
-	if (CommandWithResult(Statement, "drop proc rpc_read") != SQL_SUCCESS)
-		printf("Unable to execute statement\n");
+	Command(Statement, "IF OBJECT_ID('rpc_read') IS NOT NULL DROP PROC rpc_read");
 
-	SQLCloseCursor(Statement);
+	ResetStatement();
 
 	Command(Statement, "create proc rpc_read @i int, @x timestamp as begin select 1 return 1234 end");
 	SQLCloseCursor(Statement);
-	SQLFreeStmt(Statement, SQL_CLOSE);
-	SQLFreeStmt(Statement, SQL_UNBIND);
 
-	if (SQLPrepare(Statement, (SQLCHAR *) "{ ? = CALL rpc_read ( ?, ? ) }" , SQL_NTS) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to prepare statement\n");
+	CHK(SQLPrepare, (Statement, (SQLCHAR *) "{ ? = CALL rpc_read ( ?, ? ) }" , SQL_NTS));
 
 	ind = 0;
-	if (SQLBindParameter(Statement, 1, SQL_PARAM_OUTPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &output, 0, &ind) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to bind output parameter\n");
+	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &output, 0, &ind));
 
 	ind2 = 0;
-	if (SQLBindParameter(Statement, 2, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &input, 0, &ind2) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to bind input parameter\n");
+	CHK(SQLBindParameter, (Statement, 2, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &input, 0, &ind2));
 
 	ind3 = 8;
-	if (SQLBindParameter(Statement, 3, SQL_PARAM_INPUT, SQL_C_BINARY, SQL_VARBINARY, 8, 0, out2, 8, &ind3) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to bind output parameter\n");
+	CHK(SQLBindParameter, (Statement, 3, SQL_PARAM_INPUT, SQL_C_BINARY, SQL_VARBINARY, 8, 0, out2, 8, &ind3));
 
-	if (SQLExecute(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to execute statement\n");
+	CHK(SQLExecute, (Statement));
 
-	if (SQLFetch(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Data not expected\n");
+	CHK(SQLFetch, (Statement));
 
 	if (SQLFetch(Statement) != SQL_NO_DATA)
 		ODBC_REPORT_ERROR("Data not expected\n");
 
 	ResetStatement();
-	CommandWithResult(Statement, "drop proc rpc_read");
+	Command(Statement, "drop proc rpc_read");
 
 	/*
 	 * Test from Joao Amaral
@@ -190,19 +146,16 @@ main(int argc, char *argv[])
 
 		ResetStatement();
 
-		CommandWithResult(Statement, "drop proc sp_test");
+		Command(Statement, "IF OBJECT_ID('sp_test') IS NOT NULL DROP PROC sp_test");
 		Command(Statement, "create proc sp_test @res int output as set @res = 456");
 
 		ResetStatement();
 
-		if (SQLPrepare(Statement, (SQLCHAR *) "{ call sp_test(?)}", SQL_NTS) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("Unable to prepare statement\n");
-		if (SQLBindParameter(Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("Unable to bind output parameter\n");
+		CHK(SQLPrepare, (Statement, (SQLCHAR *) "{ call sp_test(?)}", SQL_NTS));
+		CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind));
 
 		output = 0xdeadbeef;
-		if (SQLExecute(Statement) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("Unable to execute statement\n");
+		CHK(SQLExecute, (Statement));
 
 		if (output != 456) {
 			fprintf(stderr, "Invalid result %d(%x)\n", (int) output, (int) output);
diff --git a/src/odbc/unittests/genparams.c b/src/odbc/unittests/genparams.c
index 6b783c9..9eb1b4f 100644
--- a/src/odbc/unittests/genparams.c
+++ b/src/odbc/unittests/genparams.c
@@ -4,7 +4,7 @@
 
 /* Test various type from odbc and to odbc */
 
-static char software_version[] = "$Id: genparams.c,v 1.23 2008/01/08 09:33:32 freddy77 Exp $";
+static char software_version[] = "$Id: genparams.c,v 1.24 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifdef TDS_NO_DM
@@ -37,34 +37,28 @@ Test(const char *type, const char *value_to_convert, SQLSMALLINT out_c_type, SQL
 
 	if (use_cursors) {
 		ResetStatement();
-		if (SQLSetStmtAttr(Statement, SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_SCROLLABLE, 0) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("SQLSetStmtAttr error");
-		if (SQLSetStmtAttr(Statement, SQL_ATTR_CURSOR_TYPE, (SQLPOINTER) SQL_CURSOR_DYNAMIC, 0) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("SQLSetStmtAttr error");
+		CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_SCROLLABLE, 0));
+		CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_CURSOR_TYPE, (SQLPOINTER) SQL_CURSOR_DYNAMIC, 0));
 	}
 
 	/* bind parameter */
 	if (exec_direct) {
-		if (SQLBindParameter(Statement, 1, SQL_PARAM_OUTPUT, out_c_type, out_sql_type, precision, 0, out_buf,
-			     sizeof(out_buf), &out_len) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("Unable to bind output parameter");
+		CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, out_c_type, out_sql_type, precision, 0, out_buf,
+			     sizeof(out_buf), &out_len));
 
 		/* call store procedure */
-		if (SQLExecDirect(Statement, (SQLCHAR *) "{call spTestProc(?)}", SQL_NTS) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("Unable to execute store statement");
+		CHK(SQLExecDirect, (Statement, (SQLCHAR *) "{call spTestProc(?)}", SQL_NTS));
 	} else {
-		if (prepare_before && SQLPrepare(Statement, (SQLCHAR *) "{call spTestProc(?)}", SQL_NTS) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("SQLPrepare() failure!");
+		if (prepare_before)
+			CHK(SQLPrepare, (Statement, (SQLCHAR *) "{call spTestProc(?)}", SQL_NTS));
 
-		if (SQLBindParameter(Statement, 1, SQL_PARAM_OUTPUT, out_c_type, out_sql_type, precision, 0, out_buf,
-			     sizeof(out_buf), &out_len) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("Unable to bind output parameter");
+		CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, out_c_type, out_sql_type, precision, 0, out_buf,
+			     sizeof(out_buf), &out_len));
 
-		if (!prepare_before && SQLPrepare(Statement, (SQLCHAR *) "{call spTestProc(?)}", SQL_NTS) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("SQLPrepare() failure!");
+		if (!prepare_before)
+			CHK(SQLPrepare, (Statement, (SQLCHAR *) "{call spTestProc(?)}", SQL_NTS));
 
-		if (SQLExecute(Statement) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("SQLExecute() failure!");
+		CHK(SQLExecute, (Statement));
 	}
 
 	/* test results */
@@ -152,16 +146,14 @@ TestInput(SQLSMALLINT out_c_type, const char *type, SQLSMALLINT out_sql_type, co
 	} else {
 		SQLRETURN rc;
 
-		if (prepare_before && SQLPrepare(Statement, (SQLCHAR *) sbuf, SQL_NTS) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("SQLPrepare() failure!");
+		if (prepare_before)
+			CHK(SQLPrepare, (Statement, (SQLCHAR *) sbuf, SQL_NTS));
 
 		out_len = 1;
-		if (SQLBindParameter(Statement, 1, SQL_PARAM_INPUT, out_c_type, out_sql_type, 20, 0, out_buf, sizeof(out_buf), &out_len) !=
-		    SQL_SUCCESS)
-			ODBC_REPORT_ERROR("Unable to bind input parameter");
+		CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, out_c_type, out_sql_type, 20, 0, out_buf, sizeof(out_buf), &out_len));
 
-		if (!prepare_before && SQLPrepare(Statement, (SQLCHAR *) sbuf, SQL_NTS) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("SQLPrepare() failure!");
+		if (!prepare_before)
+			CHK(SQLPrepare, (Statement, (SQLCHAR *) sbuf, SQL_NTS));
 
 		rc = SQLExecute(Statement);
 		if (rc != SQL_SUCCESS && rc != SQL_NO_DATA)
@@ -173,8 +165,7 @@ TestInput(SQLSMALLINT out_c_type, const char *type, SQLSMALLINT out_sql_type, co
 	sprintf(sbuf, "SELECT * FROM #tmp_insert WHERE col = CONVERT(%s, '%s')", param_type, expected);
 	Command(Statement, sbuf);
 
-	if (SQLFetch(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Expected row");
+	CHK(SQLFetch, (Statement));
 	if (SQLFetch(Statement) != SQL_NO_DATA)
 		ODBC_REPORT_ERROR("Row not expected");
 	if (SQLMoreResults(Statement) != SQL_NO_DATA)
diff --git a/src/odbc/unittests/getdata.c b/src/odbc/unittests/getdata.c
index 1752423..8520ca1 100644
--- a/src/odbc/unittests/getdata.c
+++ b/src/odbc/unittests/getdata.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: getdata.c,v 1.5 2008/01/29 09:35:25 freddy77 Exp $";
+static char software_version[] = "$Id: getdata.c,v 1.6 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char odbc_err[256];
@@ -55,11 +55,7 @@ main(int argc, char *argv[])
 	/* TODO test with VARCHAR too */
 	Command(Statement, "SELECT CONVERT(TEXT,'Prova')");
 
-	if (SQLFetch(Statement) != SQL_SUCCESS) {
-		printf("Unable to fetch row\n");
-		CheckReturn();
-		exit(1);
-	}
+	CHK(SQLFetch, (Statement));
 
 	/* these 2 tests test an old severe BUG in FreeTDS */
 	if (SQLGetData(Statement, 1, SQL_C_CHAR, buf, 0, NULL) != SQL_SUCCESS_WITH_INFO)
@@ -75,8 +71,7 @@ main(int argc, char *argv[])
 		exit(1);
 	}
 
-	if (SQLGetData(Statement, 1, SQL_C_CHAR, buf, 16, NULL) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to get data");
+	CHK(SQLGetData, (Statement, 1, SQL_C_CHAR, buf, 16, NULL));
 	if (strcmp(buf, "ova") != 0) {
 		printf("Wrong data result 2 res = '%s'\n", buf);
 		exit(1);
@@ -87,8 +82,7 @@ main(int argc, char *argv[])
 	/* test with varchar, not blob but variable */
 	Command(Statement, "SELECT CONVERT(VARCHAR(100), 'Other test')");
 
-	if (SQLFetch(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to fetch row");
+	CHK(SQLFetch, (Statement));
 
 	if (SQLGetData(Statement, 1, SQL_C_CHAR, buf, 7, NULL) != SQL_SUCCESS_WITH_INFO)
 		ODBC_REPORT_ERROR("Unable to get data");
@@ -97,8 +91,7 @@ main(int argc, char *argv[])
 		exit(1);
 	}
 
-	if (SQLGetData(Statement, 1, SQL_C_CHAR, buf, 16, NULL) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to get data");
+	CHK(SQLGetData, (Statement, 1, SQL_C_CHAR, buf, 16, NULL));
 	if (strcmp(buf, "test") != 0) {
 		printf("Wrong data result 2 res = '%s'\n", buf);
 		exit(1);
@@ -109,12 +102,10 @@ main(int argc, char *argv[])
 	/* test with fixed length */
 	Command(Statement, "SELECT CONVERT(INT, 12345)");
 
-	if (SQLFetch(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to fetch row");
+	CHK(SQLFetch, (Statement));
 
 	int_buf = 0xdeadbeef;
-	if (SQLGetData(Statement, 1, SQL_C_SLONG, &int_buf, 0, NULL) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to get data");
+	CHK(SQLGetData, (Statement, 1, SQL_C_SLONG, &int_buf, 0, NULL));
 	if (int_buf != 12345) {
 		printf("Wrong data result\n");
 		exit(1);
@@ -149,12 +140,10 @@ main(int argc, char *argv[])
 	if (db_is_microsoft()) {
 		Command(Statement, "SELECT CONVERT(TEXT,'')");
 
-		if (SQLFetch(Statement) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("Unable to fetch row");
+		CHK(SQLFetch, (Statement));
 
 		len = 1234;
-		if (SQLGetData(Statement, 1, SQL_C_CHAR, buf, 1, &len) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("invalid return from SQLGetData");
+		CHK(SQLGetData, (Statement, 1, SQL_C_CHAR, buf, 1, &len));
 
 		if (len != 0) {
 			fprintf(stderr, "Wrong len returned, returned %ld\n", (long) len);
diff --git a/src/odbc/unittests/hidden.c b/src/odbc/unittests/hidden.c
index 71124a6..b02881e 100755
--- a/src/odbc/unittests/hidden.c
+++ b/src/odbc/unittests/hidden.c
@@ -3,7 +3,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: hidden.c,v 1.3 2008/01/10 21:19:47 freddy77 Exp $";
+static char software_version[] = "$Id: hidden.c,v 1.4 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define CHECK_RCODE(t,h,m) \
@@ -41,7 +41,6 @@ int
 main(int argc, char **argv)
 {
 	SQLRETURN rcode;
-	SQLHSTMT m_hstmt1;
 	SQLSMALLINT cnt = 0;
 	int failed = 0;
 
@@ -54,13 +53,10 @@ main(int argc, char **argv)
 	/* test hidden column with FOR BROWSE */
 	ResetStatement();
 
-	m_hstmt1 = Statement;
+	Command(Statement, "SELECT c, b FROM #tmp1");
 
-	rcode = SQLExecDirect(m_hstmt1, (SQLCHAR *) "SELECT c, b FROM #tmp1", SQL_NTS);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLExecDirect");
-
-	rcode = SQLNumResultCols(m_hstmt1, &cnt);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLNumResultCols 1");
+	rcode = SQLNumResultCols(Statement, &cnt);
+	CHECK_RCODE(SQL_HANDLE_STMT, Statement, "SQLNumResultCols 1");
 
 	if (cnt != 2) {
 		fprintf(stderr, "Wrong number of columns in result set: %d\n", (int) cnt);
@@ -70,21 +66,20 @@ main(int argc, char **argv)
 
 	/* test hidden column with cursors*/
 	CheckCursor();
-	m_hstmt1 = Statement;
 
-	rcode = SQLSetStmtAttr(m_hstmt1, SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_NONSCROLLABLE, SQL_IS_UINTEGER);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLSetStmtAttr SQL_ATTR_CURSOR_SCROLLABLE");
-	rcode = SQLSetStmtAttr(m_hstmt1, SQL_ATTR_CURSOR_SENSITIVITY, (SQLPOINTER) SQL_SENSITIVE, SQL_IS_UINTEGER);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLSetStmtAttr SQL_ATTR_CURSOR_SENSITIVITY");
+	rcode = SQLSetStmtAttr(Statement, SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_NONSCROLLABLE, SQL_IS_UINTEGER);
+	CHECK_RCODE(SQL_HANDLE_STMT, Statement, "SQLSetStmtAttr SQL_ATTR_CURSOR_SCROLLABLE");
+	rcode = SQLSetStmtAttr(Statement, SQL_ATTR_CURSOR_SENSITIVITY, (SQLPOINTER) SQL_SENSITIVE, SQL_IS_UINTEGER);
+	CHECK_RCODE(SQL_HANDLE_STMT, Statement, "SQLSetStmtAttr SQL_ATTR_CURSOR_SENSITIVITY");
 
-	rcode = SQLPrepare(m_hstmt1, (SQLCHAR *) "SELECT * FROM #t1", SQL_NTS);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLPrepare 1");
+	rcode = SQLPrepare(Statement, (SQLCHAR *) "SELECT * FROM #t1", SQL_NTS);
+	CHECK_RCODE(SQL_HANDLE_STMT, Statement, "SQLPrepare 1");
 
-	rcode = SQLExecute(m_hstmt1);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLExecute 1");
+	rcode = SQLExecute(Statement);
+	CHECK_RCODE(SQL_HANDLE_STMT, Statement, "SQLExecute 1");
 
-	rcode = SQLNumResultCols(m_hstmt1, &cnt);
-	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLNumResultCols 1");
+	rcode = SQLNumResultCols(Statement, &cnt);
+	CHECK_RCODE(SQL_HANDLE_STMT, Statement, "SQLNumResultCols 1");
 
 	if (cnt != 3) {
 		fprintf(stderr, "Wrong number of columns in result set: %d\n", (int) cnt);
diff --git a/src/odbc/unittests/lang_error.c b/src/odbc/unittests/lang_error.c
index 7634934..90192b4 100644
--- a/src/odbc/unittests/lang_error.c
+++ b/src/odbc/unittests/lang_error.c
@@ -2,7 +2,7 @@
 
 /* Test if SQLExecDirect return error if a error in row is returned */
 
-static char software_version[] = "$Id: lang_error.c,v 1.2 2003/11/08 18:00:33 freddy77 Exp $";
+static char software_version[] = "$Id: lang_error.c,v 1.3 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -12,7 +12,7 @@ main(int argc, char *argv[])
 
 	/* issue print statement and test message returned */
 	if (CommandWithResult(Statement, "SELECT DATEADD(dd,-100000,getdate())") != SQL_ERROR) {
-		printf("SQLExecDirect should return SQL_ERROR\n");
+		fprintf(stderr, "SQLExecDirect should return SQL_ERROR\n");
 		return 1;
 	}
 
diff --git a/src/odbc/unittests/moreandcount.c b/src/odbc/unittests/moreandcount.c
index 4c922dc..95ae329 100644
--- a/src/odbc/unittests/moreandcount.c
+++ b/src/odbc/unittests/moreandcount.c
@@ -2,7 +2,7 @@
 
 /* Test for SQLMoreResults and SQLRowCount on batch */
 
-static char software_version[] = "$Id: moreandcount.c,v 1.14 2006/07/13 08:21:56 freddy77 Exp $";
+static char software_version[] = "$Id: moreandcount.c,v 1.15 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
@@ -45,21 +45,12 @@ DoTest(int prepare)
 		"UPDATE #tmp1 SET i=i+1 WHERE i >= 2";
 
 	if (prepare) {
-		if (SQLPrepare(Statement, (SQLCHAR *) query, SQL_NTS) != SQL_SUCCESS) {
-			printf("Unable to prepare statement\n");
-			exit(1);
-		}
-		if (SQLExecute(Statement) != SQL_SUCCESS) {
-			printf("Unable to execute statement\n");
-			exit(1);
-		}
+		CHK(SQLPrepare, (Statement, (SQLCHAR *) query, SQL_NTS));
+		CHK(SQLExecute, (Statement));
 	} else {
 
 		/* execute a batch command select insert insert select and check rows */
-		if (SQLExecDirect(Statement, (SQLCHAR *) query, SQL_NTS) != SQL_SUCCESS) {
-			printf("Unable to execute direct statement\n");
-			exit(1);
-		}
+		CHK(SQLExecDirect, (Statement, (SQLCHAR *) query, SQL_NTS));
 	}
 	if (!prepare) {
 		printf("Result %d\n", ++n);
diff --git a/src/odbc/unittests/norowset.c b/src/odbc/unittests/norowset.c
index 6a6afb3..b18245c 100644
--- a/src/odbc/unittests/norowset.c
+++ b/src/odbc/unittests/norowset.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: norowset.c,v 1.5 2006/03/23 14:53:44 freddy77 Exp $";
+static char software_version[] = "$Id: norowset.c,v 1.6 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 /* Test that a select following a store procedure execution return results */
@@ -22,18 +22,9 @@ main(int argc, char *argv[])
 
 	/* note, mssql 2005 seems to not return row for tempdb, use always master */
 	Command(Statement, "select name from master..sysobjects where name = 'sysobjects'");
-	res = SQLFetch(Statement);
-	if (res != SQL_SUCCESS) {
-		printf("Unable to fetch row\n");
-		CheckReturn();
-		exit(1);
-	}
+	CHK(SQLFetch, (Statement));
 
-	if (SQLGetData(Statement, 1, SQL_C_CHAR, output, sizeof(output), &dataSize) != SQL_SUCCESS) {
-		printf("Unable to get data col %d\n", 1);
-		CheckReturn();
-		exit(1);
-	}
+	CHK(SQLGetData, (Statement, 1, SQL_C_CHAR, output, sizeof(output), &dataSize));
 
 	if (strcmp(output, "sysobjects") != 0) {
 		printf("Unexpected result\n");
@@ -42,13 +33,12 @@ main(int argc, char *argv[])
 
 	res = SQLFetch(Statement);
 	if (res != SQL_NO_DATA) {
-		printf("Row not expected\n");
+		fprintf(stderr, "Row not expected\n");
 		CheckReturn();
-		exit(1);
 	}
 
 	if (SQLMoreResults(Statement) != SQL_NO_DATA) {
-		printf("Not expected another recordset\n");
+		fprintf(stderr, "Not expected another recordset\n");
 		exit(1);
 	}
 
diff --git a/src/odbc/unittests/params.c b/src/odbc/unittests/params.c
index cbf01ee..191066c 100644
--- a/src/odbc/unittests/params.c
+++ b/src/odbc/unittests/params.c
@@ -3,7 +3,7 @@
 /* Test for store procedure and params */
 /* Test from Tom Rogers */
 
-static char software_version[] = "$Id: params.c,v 1.7 2005/03/29 15:19:36 freddy77 Exp $";
+static char software_version[] = "$Id: params.c,v 1.8 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 /* SP definition */
@@ -39,51 +39,22 @@ Test(int bind_before)
 	/* create proc */
 	Command(Statement, sp_define);
 
-	if (!bind_before) {
-		if (SQLPrepare(Statement, (SQLCHAR *) SP_TEXT, strlen(SP_TEXT)) != SQL_SUCCESS) {
-			fprintf(stderr, "Unable to prepare statement\n");
-			return 1;
-		}
-	}
-
-	if (SQLBindParameter(Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SSHORT, SQL_INTEGER, 0, 0, &ReturnCode, 0, &cbReturnCode) !=
-	    SQL_SUCCESS) {
-		fprintf(stderr, "Unable to bind input parameter\n");
-		return 1;
-	}
-
-	if (SQLBindParameter(Statement, 2, SQL_PARAM_INPUT, SQL_C_SSHORT, SQL_INTEGER, 0, 0, &InParam, 0, &cbInParam) !=
-	    SQL_SUCCESS) {
-		fprintf(stderr, "Unable to bind input parameter\n");
-		return 1;
-	}
+	if (!bind_before)
+		CHK(SQLPrepare, (Statement, (SQLCHAR *) SP_TEXT, strlen(SP_TEXT)));
 
-	if (SQLBindParameter(Statement, 3, SQL_PARAM_OUTPUT, SQL_C_SSHORT, SQL_INTEGER, 0, 0, &OutParam, 0, &cbOutParam) !=
-	    SQL_SUCCESS) {
-		fprintf(stderr, "Unable to bind input parameter\n");
-		return 1;
-	}
+	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SSHORT, SQL_INTEGER, 0, 0, &ReturnCode, 0, &cbReturnCode));
+	CHK(SQLBindParameter, (Statement, 2, SQL_PARAM_INPUT,  SQL_C_SSHORT, SQL_INTEGER, 0, 0, &InParam,    0, &cbInParam));
+	CHK(SQLBindParameter, (Statement, 3, SQL_PARAM_OUTPUT, SQL_C_SSHORT, SQL_INTEGER, 0, 0, &OutParam,   0, &cbOutParam));
 
 	OutString[0] = '\0';
 	strcpy(OutString, "Test");	/* Comment this line and we get an error!  Why? */
-	if (SQLBindParameter
-	    (Statement, 4, SQL_PARAM_OUTPUT, SQL_C_CHAR, SQL_VARCHAR, OUTSTRING_LEN, 0, OutString, OUTSTRING_LEN,
-	     &cbOutString) != SQL_SUCCESS) {
-		fprintf(stderr, "Unable to bind input parameter\n");
-		return 1;
-	}
+	CHK(SQLBindParameter, (Statement, 4, SQL_PARAM_OUTPUT, SQL_C_CHAR, SQL_VARCHAR, OUTSTRING_LEN, 0, OutString, 
+	    OUTSTRING_LEN, &cbOutString));
 
-	if (bind_before) {
-		if (SQLPrepare(Statement, (SQLCHAR *) SP_TEXT, strlen(SP_TEXT)) != SQL_SUCCESS) {
-			fprintf(stderr, "Unable to prepare statement\n");
-			return 1;
-		}
-	}
+	if (bind_before)
+		CHK(SQLPrepare, (Statement, (SQLCHAR *) SP_TEXT, strlen(SP_TEXT)));
 
-	if (SQLExecute(Statement) != SQL_SUCCESS) {
-		fprintf(stderr, "Unable to execute statement\n");
-		return 1;
-	}
+	CHK(SQLExecute, (Statement));
 
 	Command(Statement, "drop proc spTestProc");
 
diff --git a/src/odbc/unittests/prepare_results.c b/src/odbc/unittests/prepare_results.c
index 651ce0a..8ebdb4e 100644
--- a/src/odbc/unittests/prepare_results.c
+++ b/src/odbc/unittests/prepare_results.c
@@ -2,7 +2,7 @@
 
 /* Test for data format returned from SQLPrepare */
 
-static char software_version[] = "$Id: prepare_results.c,v 1.8 2007/06/19 12:07:59 freddy77 Exp $";
+static char software_version[] = "$Id: prepare_results.c,v 1.9 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -22,11 +22,9 @@ main(int argc, char *argv[])
 	SQLMoreResults(Statement);
 
 	/* test query returns column information for update */
-	if (SQLPrepare(Statement, (SQLCHAR *) "update #odbctestdata set i = 20", SQL_NTS) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLPrepare return failure");
+	CHK(SQLPrepare, (Statement, (SQLCHAR *) "update #odbctestdata set i = 20", SQL_NTS));
 
-	if (SQLNumResultCols(Statement, &count) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLNumResultCols return failure");
+	CHK(SQLNumResultCols, (Statement, &count));
 
 	if (count != 0) {
 		fprintf(stderr, "Wrong number of columns returned. Got %d expected 0\n", (int) count);
@@ -34,35 +32,30 @@ main(int argc, char *argv[])
 	}
 
 	/* test query returns column information */
-	if (SQLPrepare(Statement, (SQLCHAR *) "select * from #odbctestdata select * from #odbctestdata", SQL_NTS) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLPrepare return failure");
+	CHK(SQLPrepare, (Statement, (SQLCHAR *) "select * from #odbctestdata select * from #odbctestdata", SQL_NTS));
 
-	if (SQLNumResultCols(Statement, &count) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLNumResultCols return failure");
+	CHK(SQLNumResultCols, (Statement, &count));
 
 	if (count != 3) {
 		fprintf(stderr, "Wrong number of columns returned. Got %d expected 3\n", (int) count);
 		exit(1);
 	}
 
-	if (SQLDescribeCol(Statement, 1, (SQLCHAR *) name, sizeof(name), &namelen, &type, &size, &digits, &nullable) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLDescribeCol failure for column 1");
+	CHK(SQLDescribeCol, (Statement, 1, (SQLCHAR *) name, sizeof(name), &namelen, &type, &size, &digits, &nullable));
 
 	if (type != SQL_INTEGER || strcmp(name, "i") != 0) {
 		fprintf(stderr, "wrong column 1 informations (type %d name '%s' size %d)\n", (int) type, name, (int) size);
 		exit(1);
 	}
 
-	if (SQLDescribeCol(Statement, 2, (SQLCHAR *) name, sizeof(name), &namelen, &type, &size, &digits, &nullable) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLDescribeCol failure for column 2");
+	CHK(SQLDescribeCol, (Statement, 2, (SQLCHAR *) name, sizeof(name), &namelen, &type, &size, &digits, &nullable));
 
 	if (type != SQL_CHAR || strcmp(name, "c") != 0 || (size != 20 && (db_is_microsoft() || size != 40))) {
 		fprintf(stderr, "wrong column 2 informations (type %d name '%s' size %d)\n", (int) type, name, (int) size);
 		exit(1);
 	}
 
-	if (SQLDescribeCol(Statement, 3, (SQLCHAR *) name, sizeof(name), &namelen, &type, &size, &digits, &nullable) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLDescribeCol failure for column 3");
+	CHK(SQLDescribeCol, (Statement, 3, (SQLCHAR *) name, sizeof(name), &namelen, &type, &size, &digits, &nullable));
 
 	if (type != SQL_NUMERIC || strcmp(name, "n") != 0 || size != 34 || digits != 12) {
 		fprintf(stderr, "wrong column 3 informations (type %d name '%s' size %d)\n", (int) type, name, (int) size);
diff --git a/src/odbc/unittests/print.c b/src/odbc/unittests/print.c
index 4033d5b..45f33dd 100644
--- a/src/odbc/unittests/print.c
+++ b/src/odbc/unittests/print.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: print.c,v 1.18 2005/12/04 11:16:30 freddy77 Exp $";
+static char software_version[] = "$Id: print.c,v 1.19 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static SQLCHAR output[256];
@@ -53,16 +53,13 @@ test(int odbc3)
 		rc = SQLFetch(Statement);
 		if (rc != SQL_ERROR)
 			ODBC_REPORT_ERROR("Still data?");
-		rc = SQLMoreResults(Statement);
-		if (rc != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("SQLMoreResults failed");
+		CHK(SQLMoreResults, (Statement));
 	}
     
 	CHECK_COLS(1);
 	CHECK_ROWS(-1);
 
-	if (SQLFetch(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLFetch no succeeded");
+	CHK(SQLFetch, (Statement));
 	CHECK_COLS(1);
 	CHECK_ROWS(-1);
 	if (SQLFetch(Statement) != SQL_NO_DATA)
